<?php
   
define('SM_PATH','../../');

define('CHANGELDAPPASS_DEBUG',0);

require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'config/config.php');
require_once(SM_PATH . 'functions/strings.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'functions/imap.php');

/* Locale setup */
$prev = bindtextdomain ('changeldappass', SM_PATH . 'plugins/change_ldappass/locale');
textdomain ('changeldappass');

if (isset($_POST['plugin_change_ldappass'])) {
	sqgetGlobalVar('cp_oldpass', $cp_oldpass, SQ_POST);
	sqgetGlobalVar('cp_newpass', $cp_newpass, SQ_POST);
	sqgetGlobalVar('cp_verify', $cp_verify, SQ_POST);
	
	sqgetGlobalVar('key', $key, SQ_COOKIE);
	sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);
	

	$plugin_change_ldappass = $_POST['plugin_change_ldappass'];
        $Messages = change_ldappass_check();
}

sqgetGlobalVar('authz', $authz, SQ_SESSION);


require_once (SM_PATH . "include/load_prefs.php");

/* Locale setup */
$prev = bindtextdomain ('squirrelmail', SM_PATH . 'locale');
textdomain ('squirrelmail');

displayPageHeader($color, "None");

/* Locale setup */
$prev = bindtextdomain ('changeldappass', SM_PATH . 'plugins/change_ldappass/locale');
textdomain ('changeldappass');


print '
<table width=95% align=center cellpadding=2 cellspacing=2 border=0>
<tr><td bgcolor="'.$color[0].'" align="center">
   <strong>'. _("Change Password") . '</strong>
</td></tr>
';

if (isset($Messages) && count($Messages)) {
    echo "<tr><td>\n";
    foreach ($Messages as $line) {
        echo htmlspecialchars($line) . "<br>\n";
    }
    echo "</td></tr>\n";
}


print '<tr><td>
    <form method=post action="'.$PHP_SELF.'">
    <table width="75%" align="center">';


print '<tr>
        <td align="right" width="50%">';

if (isset($authz)) { /* Check for proxy mode */

	print _("Change password for user");
	print ': </td><td width="50%">'. $authz . '</td>
      </tr>';

} else { /* Normal mode */
	print _("Old Password");
	print ':</td>
        <td width="50%"><input type=password name=cp_oldpass value=""  size=20></td>
      </tr>';
}

print '<tr>
        <td align=right>';
	print _("New Password");
	print ':</td>
        <td><input type=password name=cp_newpass value="" size=20></td>
      </tr>
      <tr>
        <td align=right>';
	print _("Verify New Password");
	print  ':</td>
        <td><input type=password name=cp_verify value="" size=20></td>
      </tr>
      <tr>
        <td align=center colspan=2><input type=submit value="';
	print _("Submit");
	print '" name="plugin_change_ldappass"></td>
      </tr>
    </table>
</td></tr>
</table>
</body></html>';


/* Functions */

function change_ldappass_check() {
   global $cp_oldpass, $cp_newpass, $cp_verify, $key, $onetimepad,
   	  $plugin_change_ldappass, $authz;

   $Messages = array();
   $password = OneTimePadDecrypt($key, $onetimepad);

   if(!isset($authz)) {
   if ($cp_oldpass == "")
       array_push($Messages, _("You must type in your old password.") );
   }

   if ($cp_newpass == "")
       array_push($Messages, _("You must type in a new password.") );

   if ($cp_verify == "")
       array_push($Messages, _("You must also type in your new password in the verify box.") );

   if ($cp_newpass != '' && $cp_verify != $cp_newpass)
       array_push($Messages, _("Your new password does not match the verify password.") );

   if(!isset($authz)) {
   if ($cp_oldpass != '' && $cp_oldpass != $password) {
		array_push($Messages, _("Your old password is not correct.") );
	}
   }

   if (count($Messages))
       return $Messages;
	
//print "DEBUG: old pass is $cp_oldpass and new pass is $cp_newpass and verify is $cp_verify and key is $key and onetimepad is $onetimepad and passowrd =$password.";


   return change_ldappass_go($password);
}


function change_ldappass_go($password) {
	global $username, $base_uri, $authz, $cp_newpass, $key, $onetimepad;
	
	include(SM_PATH . "plugins/change_ldappass/config.php");

	$Messages = array();

	// if (CHANGELDAPPASS_DEBUG == 1)
	//        array_push($Messages, _("Connecting to Directory Server") );

	$ds=ldap_connect($ldap_server);

	if (! $ds) {
		array_push($Messages, _("Could not connect to Directory Server. Please try again later.") );
	 		return $Messages;
 	}

	$r=ldap_bind($ds,$ldap_manager_dn,$ldap_manager_pw);

	if(isset($authz)) {
		$sr=ldap_search($ds,$ldap_base_dn, "uid=$authz",array('uid'));
	} else {
		$sr=ldap_search($ds,$ldap_base_dn, "uid=$username",array('uid', $ldap_password_field));
	}

	if (ldap_count_entries($ds,$sr)!=1) {	//make sure we only have 1 uid
 		array_push($Messages, _("Duplicate (or no) login entries detected, cannot change password.") );
 		return $Messages;
	}
	
	$info = ldap_get_entries($ds, $sr);
	$dn=$info[0]["dn"];

	if(!isset($authz)) {
		$lpass = $info[0][$ldap_password_field][0];
		$cpass=crypt($password,substr($lpass,7,2));

		if ($lpass!="{CRYPT}$cpass") {
			// print "lpass = $lpass  , cpass = $cpass";
			array_push($Messages, _("Your old password is not correct.") );
			return $Messages;
		}
	}

	$salt = substr($cp_newpass,0,2);

	$newpass="{CRYPT}".crypt($cp_newpass,substr($cp_newpass,0,2));
		
	$newinfo[$ldap_password_field]=$newpass;
	if (ldap_modify($ds,$dn,$newinfo)) {
		if (CHANGELDAPPASS_DEBUG == 1)
			array_push($Messages, _("Password changed successfully.") );

		if(!isset($authz)) {
			/* Write new cookie for the password */
			$onetimepad = OneTimePadCreate(strlen($cp_newpass));
       			sqsession_register($onetimepad,'onetimepad');
	
			$key = OneTimePadEncrypt($cp_newpass, $onetimepad);
			setcookie("key", $key, 0, $base_uri);
		}
			
			
		// Automatically forward back to the options screen if correct
		if (CHANGELDAPPASS_DEBUG != 1) {
			//header("Location: $base_uri/src/options.php?plugin_change_ldappass=true");
			header("Location: ../../src/options.php?plugin_change_ldappass=true");
			exit(0);
		}
		
		return $Messages;

	} else {

		array_push($Messages, _("LDAP Password change failed.") );
		return $Messages;
	}
	@ldap_close($ds);
}

?>
